(function (thisObj) {
// ----- EXTENDSCRIPT INCLUDES ------ //
"object"!=typeof JSON&&(JSON={}),function(){"use strict";var rx_one=/^[\],:{}\s]*$/,rx_two=/\\(?:["\\\/bfnrt]|u[0-9a-fA-F]{4})/g,rx_three=/"[^"\\\n\r]*"|true|false|null|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?/g,rx_four=/(?:^|:|,)(?:\s*\[)+/g,rx_escapable=/[\\\"\u0000-\u001f\u007f-\u009f\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,rx_dangerous=/[\u0000\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,gap,indent,meta,rep;function f(t){return t<10?"0"+t:t}function this_value(){return this.valueOf()}function quote(t){return rx_escapable.lastIndex=0,rx_escapable.test(t)?'"'+t.replace(rx_escapable,function(t){var e=meta[t];return"string"==typeof e?e:"\\u"+("0000"+t.charCodeAt(0).toString(16)).slice(-4)})+'"':'"'+t+'"'}function str(t,e){var r,n,o,u,f,a=gap,i=e[t];switch(i&&"object"==typeof i&&"function"==typeof i.toJSON&&(i=i.toJSON(t)),"function"==typeof rep&&(i=rep.call(e,t,i)),typeof i){case"string":return quote(i);case"number":return isFinite(i)?String(i):"null";case"boolean":case"null":return String(i);case"object":if(!i)return"null";if(gap+=indent,f=[],"[object Array]"===Object.prototype.toString.apply(i)){for(u=i.length,r=0;r<u;r+=1)f[r]=str(r,i)||"null";return o=0===f.length?"[]":gap?"[\n"+gap+f.join(",\n"+gap)+"\n"+a+"]":"["+f.join(",")+"]",gap=a,o}if(rep&&"object"==typeof rep)for(u=rep.length,r=0;r<u;r+=1)"string"==typeof rep[r]&&(o=str(n=rep[r],i))&&f.push(quote(n)+(gap?": ":":")+o);else for(n in i)Object.prototype.hasOwnProperty.call(i,n)&&(o=str(n,i))&&f.push(quote(n)+(gap?": ":":")+o);return o=0===f.length?"{}":gap?"{\n"+gap+f.join(",\n"+gap)+"\n"+a+"}":"{"+f.join(",")+"}",gap=a,o}}"function"!=typeof Date.prototype.toJSON&&(Date.prototype.toJSON=function(){return isFinite(this.valueOf())?this.getUTCFullYear()+"-"+f(this.getUTCMonth()+1)+"-"+f(this.getUTCDate())+"T"+f(this.getUTCHours())+":"+f(this.getUTCMinutes())+":"+f(this.getUTCSeconds())+"Z":null},Boolean.prototype.toJSON=this_value,Number.prototype.toJSON=this_value,String.prototype.toJSON=this_value),"function"!=typeof JSON.stringify&&(meta={"\b":"\\b","\t":"\\t","\n":"\\n","\f":"\\f","\r":"\\r",'"':'\\"',"\\":"\\\\"},JSON.stringify=function(t,e,r){var n;if(gap="",indent="","number"==typeof r)for(n=0;n<r;n+=1)indent+=" ";else"string"==typeof r&&(indent=r);if(rep=e,e&&"function"!=typeof e&&("object"!=typeof e||"number"!=typeof e.length))throw new Error("JSON.stringify");return str("",{"":t})}),"function"!=typeof JSON.parse&&(JSON.parse=function(text,reviver){var j;function walk(t,e){var r,n,o=t[e];if(o&&"object"==typeof o)for(r in o)Object.prototype.hasOwnProperty.call(o,r)&&(void 0!==(n=walk(o,r))?o[r]=n:delete o[r]);return reviver.call(t,e,o)}if(text=String(text),rx_dangerous.lastIndex=0,rx_dangerous.test(text)&&(text=text.replace(rx_dangerous,function(t){return"\\u"+("0000"+t.charCodeAt(0).toString(16)).slice(-4)})),rx_one.test(text.replace(rx_two,"@").replace(rx_three,"]").replace(rx_four,"")))return j=eval("("+text+")"),"function"==typeof reviver?walk({"":j},""):j;throw new SyntaxError("JSON.parse")})}();
// ---------------------------------- //
// ----- EXTENDSCRIPT PONYFILLS -----
function __objectFreeze(obj) { return obj; }
// ---------------------------------- //
var version = "0.3.4";

var config = {
  version: version,
  id: "com.mcraimer.trasncribeprox",
  displayName: "SmartCaptions",
  symlink: "local",
  port: 3000,
  servePort: 5000,
  startingDebugPort: 8860,
  extensionManifestVersion: 6.0,
  requiredRuntimeVersion: 9.0,
  hosts: [{
    name: "PPRO",
    version: "[0.0,99.9]"
  }],
  type: "Panel",
  iconDarkNormal: "./src/assets/light-icon.png",
  iconNormal: "./src/assets/dark-icon.png",
  iconDarkNormalRollOver: "./src/assets/light-icon.png",
  iconNormalRollOver: "./src/assets/dark-icon.png",
  parameters: ["--v=0", "--enable-nodejs", "--mixed-context", "--allow-file-access"],
  width: 810,
  height: 690,
  panels: [{
    mainPath: "./main/index.html",
    name: "SmartCaptions",
    panelDisplayName: "SmartCaptions",
    autoVisible: true,
    width: 810,
    height: 690
  }],
  build: {
    jsxBin: "off",
    sourceMap: true
  },
  zxp: {
    country: "IL",
    province: "JLM",
    org: "SmartCaptions",
    password: "mypassword",
    tsa: "http://timestamp.digicert.com/",
    sourceMap: false,
    jsxBin: "off"
  },
  installModules: [],
  copyAssets: ["static"],
  copyZipAssets: []
};

var ns = config.id;

/**
 * @function dispatchTS Displatches an event to the CEP panel with Type-Safety
 * See listenTS() in the CEP panel for more info
 * @param event The event name to listen for (defined in EventTS in shared/universals.ts)
 * @param callback The callback function to be executed when the event is triggered
 */
var dispatchTS = function dispatchTS(event, data) {
  if (new ExternalObject("lib:PlugPlugExternalObject")) {
    var eventObj = new CSXSEvent();
    eventObj.type = "".concat(ns, ".").concat(event);
    eventObj.data = JSON.stringify(data);
    eventObj.dispatch();
  }
};

// ProjectItem Helpers
var ticksToTime = function ticksToTime(ticks) {
  var time = new Time();
  time.ticks = ticks;
  return time;
};

//Transcription and audio extraction
var exportMp3FromSequence = function exportMp3FromSequence(allOrSelection) {
  var extensionFolder = $.fileName.substring(0, $.fileName.lastIndexOf('/jsx/'));
  var separtor = $.os.indexOf("Win") !== -1 ? "\\" : "/";
  var tempFolder = getTempFolder();
  var filepath = File(tempFolder + "".concat(separtor + app.project.activeSequence.sequenceID).concat(Math.random() * 10000, ".mp3")).fsName;
  var eprPath = File(extensionFolder + "".concat(separtor, "static").concat(separtor, "MP3.epr")).fsName;
  app.project.activeSequence.exportAsMediaDirect(filepath, eprPath, allOrSelection);
  var inPointSeconds = app.project.activeSequence.getInPointAsTime().seconds > 0 ? app.project.activeSequence.getInPointAsTime().seconds : 0;
  var sequenceLength = allOrSelection === 0 ? ticksToTime(app.project.activeSequence.end).seconds : app.project.activeSequence.getOutPointAsTime().seconds - inPointSeconds;
  dispatchTS("mp3Created", {
    extensionFolder: extensionFolder,
    mp3Path: filepath,
    captionsOffset: allOrSelection === 0 ? 0 : inPointSeconds,
    sequenceLength: Math.round(sequenceLength)
  });
  return filepath;
};
var importSrtAddToCaptionTrack = function importSrtAddToCaptionTrack(srtFilePath, captionOffset) {
  var destBin = app.project.getInsertionBin();
  if (destBin) {
    var prevItemCount = destBin.children.numItems;
    if (app.project) {
      var importThese = [srtFilePath];
      if (importThese) {
        var suppressWarnings = true;
        var importAsStills = false;
        app.project.importFiles(importThese, suppressWarnings, app.project.getInsertionBin(), importAsStills);
      } else {
        // $._PPP_.updateEventPanel("Invalid .srt file path.");
        return;
      }
      var newItemCount = destBin.children.numItems;
      if (newItemCount > prevItemCount) {
        var importedSRT = destBin.children[newItemCount - 1];
        if (importedSRT) {
          var activeSeq = app.project.activeSequence;
          if (activeSeq) {
            app.project.activeSequence.createCaptionTrack(importedSRT, captionOffset, Sequence.CAPTION_FORMAT_SUBTITLE);
          }
        }
      }
    }
  }
};
function getTempFolder() {
  return $.global['app']['getAppPrefPath'];
}
function addMessageToPProEventsInfo(msg) {
  app.setSDKEventMessage("".concat(msg), "info");
}

var ppro = /*#__PURE__*/__objectFreeze({
  __proto__: null,
  exportMp3FromSequence: exportMp3FromSequence,
  importSrtAddToCaptionTrack: importSrtAddToCaptionTrack,
  getTempFolder: getTempFolder,
  addMessageToPProEventsInfo: addMessageToPProEventsInfo
});

var host = typeof $ !== "undefined" ? $ : window;
switch (BridgeTalk.appName) {
  case "premierepro":
  case "premiereprobeta":
    host[ns] = ppro;
    break;
}

// https://extendscript.docsforadobe.dev/interapplication-communication/bridgetalk-class.html?highlight=bridgetalk#appname

})(this);